drop table  new_books;
drop table  new_journals ;
drop table  shelved_books ;
drop table  Author ;
drop table  issue ;
drop table  Class ;
drop table  J_issue ;
drop table  claim ;

drop table Fine_Details ;
drop table Userclass ;
drop table Journal ;
drop table Users ;
drop table Books ;

create table Books
(  constraint Pk_Books  primary key (Acc_num),
   Acc_num integer not null,
   ISBN    integer,
   Publisher varchar(50),
   Book_name varchar(30),
   Class_num varchar(10),
   Edition varchar(2),
   Obtained_from varchar(50),
   ValueI varchar(1) ,
   ValueC varchar(1) ,
   ValueL varchar(1) ,
   Price   numeric(10,2) );

create table Journal
(
   constraint Pk_Journal primary key(JAcc_num),
   JAcc_num integer not null,
   JISBN    integer , 
   Journal_name varchar(100),
   JClass_num varchar(10),
   Journal_date  date ,
   Journal_cost numeric(10,2), 
   notify_addr varchar(100),
   expiry_date  date ,
   frequency   varchar(13),
   JvalueI char(1),
   JvalueC char(1),
   JvalueL char(1) ) ;   

create table Author 
(
  ISBN  integer not null,
  AuthorName varchar(20) not null
);

create table Users
(
  constraint Pk_Users primary key(user_id),
  user_id    integer not null,
  user_name  varchar(50),
  user_dept  varchar(10),
  user_email varchar(40),
  activation char(1)) ;


create table Userclass
(    
  constraint  Pk_UserClass primary key(category),
  category varchar(5) ,
  books_allowed smallint ,
  duration  smallint, 
  claims_allowed smallint ) ;

create table Fine_Details
(
   constraint Pk_Fines primary key(user_id, acc_num, due_date),
   user_id      integer not null ,
   acc_num      integer not null,
   due_date     date not null,
   return_date  date,
   fine_tot     numeric(5,2),
   paid         char(1) ) ; 



create table Class
( 
user_id  integer,
category varchar(5),
foreign key(user_id) references Users,
foreign key(category) references Userclass );


create table issue
( 
  acc_num    integer,
  user_id    integer,
  issue_date date,
  category varchar(5),
  fine         numeric(5,2),
  primary key(user_id, acc_num),
  foreign key(user_id) references Users,
  foreign key(acc_num) references Books );

create table claim 
( 
 acc_num     integer,
 user_id     integer,
 claim_no    smallint,
 primary key(user_id, acc_num),
 foreign key(user_id) references Users,
 foreign key(acc_num) references Books );
 
create table shelved_books
(
 acc_num integer not null,
 Book_name varchar(30) not null,
 Edition   varchar(2) ,
 claim_start  date not null,
 claim_no    smallint,
 foreign key (acc_num) references Books );



create table J_issue
(
 acc_num     integer,
 user_id     integer,
 issue_date  date,
 category    varchar(5),
 fine          numeric(5,2) ,  
 primary key(user_id,acc_num),
 foreign key(category) references Userclass,
 foreign key(user_id) references Users,
 foreign key(acc_num) references Journal);
 

create table new_journals
(
  constraint Pk_newjournals primary key(Journal_name, Journal_date),
   Journal_name varchar(100),
   Journal_date  date ,
   notify_addr varchar(100),
   frequency   varchar(13),
   Jdetails varchar(100), 
   Journal_cost numeric(10,2) 
 ); 
	
create table new_books	
(  
constraint Pk_newBooks  primary key (Book_name, Author_name, Edition),
   Publisher varchar(50),
   Book_name varchar(30),
   Author_Name varchar(30),
   Edition varchar(2),
   details varchar(100),
   Price   numeric(10,2) );
